// FlickerFreeDemoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "memdc.h"
#include "FlickerFreeDemo.h"
#include "FlickerFreeDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFlickerFreeDemoDlg-Dialogfeld

CFlickerFreeDemoDlg::CFlickerFreeDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFlickerFreeDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFlickerFreeDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PLOT, Movingpixelplot);
}

BEGIN_MESSAGE_MAP(CFlickerFreeDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CFlickerFreeDemoDlg::OnInitDialog()
{
	// Timer Starten
	SetTimer(1, 1, NULL);
	
	CDialog::OnInitDialog();
	
	// Ausgabebereich Initialisieren
	CRect rc=Movingpixelplot.GetSize();
	Movingpixelplot.SetSize(rc.Width(), rc.Height());
	Movingpixelplot.SetPlotDataSize(rc.Width()/4,rc.Height()/4);
	PixelArray.SetSize(rc.Width()/4,rc.Height()/4);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten


}

void CFlickerFreeDemoDlg::OnTimer(UINT nIDEvent) 
{
	PixelArray.IterateNewContent();
	Movingpixelplot.SetPlotData(PixelArray.GetArray());	
	Movingpixelplot.UpdatePlot();	

}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CFlickerFreeDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}